package operators

import (
	"fmt"
	"os"
	"regexp"
)

func Deps(file string) ([]string, error) {
	file = ExpandedAbsFilepath(file)
	f, err := os.ReadFile(file)
	if err != nil {
		return []string{}, fmt.Errorf("  \033[2m└\033[0m \033[91mError:\033[0m the file %q could not be read", file)
	}
	re := regexp.MustCompile(`\(load-mod\s+"?([^\s\(\)\:\"]+)"?\s*(.*)\s*\)`)
	matches := re.FindAllStringSubmatch(string(f), -1)
	if len(matches) == 0 {
		return []string{}, fmt.Errorf("  \033[2m└\033[0m \033[91mError:\033[0m there are no dependencies to install")

	}
	out := make([]string, 0, len(matches))
	for _, m := range matches {
		if len(m) > 1 && m[1] != "" {
			out = append(out, m[1])
		}
	}

	return out, nil
}
