package operators

import (
	"fmt"
	"os"
	"path/filepath"
	"strings"
)

func ShowInstalled(global bool, globalText string) error {
	modDir := GlobalPath
	if !global {
		modDir = GetModBaseDir()
	}
	files, err := filepath.Glob(filepath.Join(modDir, "*"))
	if err != nil {
		return fmt.Errorf("  \033[2m└\033[0m \033[91mError:\033[0m Could not glob module folder")
	}
	fmt.Printf("\033[1;33mInstalled Packages\033[0m%s\n", globalText)
	out := make([]string, 0, len(files))
	for _, file := range files {
		f, err := os.Stat(file)
		if err != nil {
			continue
		}
		if f.IsDir() {
			out = append(out, fmt.Sprintf("  \033[2m├\033[0m %s", f.Name()))
		}
	}
	if len(out) > 0 {
		out[len(out)-1] = strings.Replace(out[len(out)-1], "├", "└", 1)
		fmt.Println(strings.Join(out, "\n"))
	} else {
		return fmt.Errorf("  \033[2m└\033[0m \033[91mError:\033[0m There are no modules currently installed")
	}
	return nil
}
