package operators

import (
	"fmt"
	"os"
	"path/filepath"
)

// Remove removes an installed package
func Remove(pkg string, global bool) error {
	modDir := GlobalPath
	if !global {
		modDir = GetModBaseDir()
	}

	path := filepath.Join(modDir, pkg)

	if _, err := os.Stat(path); err != nil {
		return fmt.Errorf("  └ \033[91mError:\033[0m package '%s' not found", pkg)
	}

	err := os.RemoveAll(path)
	if err != nil {
		return fmt.Errorf("  └ \033[91mError:\033[0m could not remove %s module directory; %s", pkg, err.Error())
	}

	return nil
}
