package operators

import (
	"fmt"
	"regexp"
)

func Search(val string) error {
	err := checkRegistry()
	if err != nil {
		return err
	}

	packages, err := getPackages()
	if err != nil {
		return err
	}

	sorted := sortPackages(packages)
	found := 0

	for _, p := range sorted {
		match, err := regexp.MatchString(fmt.Sprintf(".*%s.*", val), p.Title)
		match2, _ := regexp.MatchString(fmt.Sprintf(".*%s.*", val), p.Description)
		if err == nil && (match || match2) {
			fmt.Println(packageString(p))
			found++
		}
	}

	if found == 0 {
		fmt.Print("  \033[31m0 modules found\033[0m\n\n")
	}

	return nil
}
